//Offset BBQ Smoker Fan Forced PID Temperature Controller. by Matt. 2021.

      //Arduino UNO. 20x4 LCD. MAXX6675 Thermocouple. 12V PC variable (3 or 4 wire) blower Fan (5V 25kHZ PWM signal). Low/high Temp relay outputs.
      //Push In encoder Switch to toggle through below Modes > Adjust encoder position to adjust setpoints > Push in encoder to Store Setpoint in EEPROM and move through back to Mode 0.
      
//Mode 0 - Running to Setpoints (Temperature Degree Celcius) (Low Alarm Relay Output for Buzzer etc) (High Temp Relay Fan Relay On/Off Pulse)
//Mode 1 - Change Temperature Setpoint (and Store)
//Mode 2 - Change Low Temperature Alarm Setpoint (and Store)
//Mode 3 - Change High Temperature Mode Setpoint (and Store)
//Mode 4 - Change P (proportional) Setpoint (and Store)
//Mode 5 - Change I (integral) Setpoint (and Store)
//Mode 6 - Change D (derivitive) Setpoint (and Store)

     //When running, ensure after adjusting setpoints that you are back in 'Mode 0' to control to temperature.

#include <PIDController.h>         //Ensure this Library is added to your Arduino IDE.
#include <EEPROM.h>                //Ensure this Library is added to your Arduino IDE.
#include <SPI.h>                   //Ensure this Library is added to your Arduino IDE.
#include <Wire.h>                  //Ensure this Library is added to your Arduino IDE.
#include <LiquidCrystal_I2C.h>     //Ensure this Library is added to your Arduino IDE.
PIDController pid;
LiquidCrystal_I2C lcd(0x27,20,4);  //Sometimes LCD Address is not 0x27 (default for 20x4 LCD). Google for other possible addresses to use.
#define lowtemppin 7
#define lowtempsilencepin 8
#define encoderswitch 12
#define hitemppin 13
#define hitempoff 15000             //when in High Temp mode this will be Pulse ON time (5 seconds. Change as desired)**consider to ammend code to calculate pulse times to be in proportion to degrees higher than High Temp SP. For me this ok.
#define hitempon 5000             //when in High Temp mode this will be Pulse OFF time (15 seconds. Change as desired)**consider to ammend code to calculate pulse times to be in proportion to degrees higher than High Temp SP. For me this ok.
#define lowtempon 4000             //when in Low Alarm this will be time Alarm Buzz is ON (1 second. Change as desired)      
#define lowtempoff 1000            //when in Low Alarm this will be time Alarm Buzz is OFF (4 seconds. Change as desired) 
int duty = 0;                 
const byte OC1A_PIN = 9; 
const byte OC1B_PIN = 10;  
const word PWM_FREQ_HZ = 25000;    //Adjust this value to adjust the frequency. Most variable PC Fans use this Frequency as default PWM Frequency (international standard). 
const word TCNT1_TOP = 16000000/(2*PWM_FREQ_HZ);
unsigned long hitempms;
unsigned long hitempmsLast;
unsigned long lowtempms;
unsigned long lowtempmsLast;
unsigned long silencems;
unsigned long silencelastms;
unsigned long cursorms;
unsigned long cursorlastms;
double Kp, Ki, Kd;
int IKp, IKi, IKd;
int hialarm, loalarm;
int unit;
double Dtempset;
double Dtemperature = 30;
int temperature = 30, tempset;
double increment = 0;
int tempstore = 0;
int testtemp = 0;   
double pidvalue = 0.00;
double Iduty = 0.00;
int menu;
int lcdrow;
int lcdcol;
int valchange;
boolean lowtemp;  
boolean hitemp;
boolean silence;
boolean menupressed;
boolean cursor;

static int pinA = 2;
static int pinB = 3;
//pinMode(pinA, INPUT_PULLUP);    
//pinMode(pinB, INPUT_PULLUP); 

volatile byte aFlag = 0; 
volatile byte bFlag = 0; 
volatile byte encoderPos = 0; 
volatile byte oldEncPos = 0; 
volatile byte reading = 0; 

void setup(void)
{
Serial.begin(9600);  
pid.begin();          
pid.limit(0, 255);

pinMode(pinA, INPUT_PULLUP);    
pinMode(pinB, INPUT_PULLUP); 

attachInterrupt(0,PinA,RISING); 
attachInterrupt(1,PinB,RISING);

pinMode(OC1A_PIN, OUTPUT);
TCCR1A = 0;
TCCR1B = 0;
TCNT1  = 0;
TCCR1A |= (1 << COM1A1) | (1 << WGM11);
TCCR1B |= (1 << WGM13) | (1 << CS10);
ICR1 = TCNT1_TOP;


IKp = EEPROM.read(0);
delay(100);
IKi = EEPROM.read(1);
delay(100);
IKd = EEPROM.read(2);
delay(100);
hialarm = EEPROM.read(3);
delay(100);
loalarm = EEPROM.read(4);
delay(100);
tempset = EEPROM.read(5);
delay(100);
unit = EEPROM.read(6);
delay(100);

if (unit == NULL)
{
unit = 1;
}
if ((unit != 1) && (unit != 2))
{
unit = 1;
}



if (IKp == NULL) 
{
IKp = 32;                  //Default initial P constant. can be changed and stored in EEPROM using Encoder. This is just the intial value on first run.
}
if (IKi == NULL) 
{
IKi = 2;                   //Default initial I constant. can be changed and stored in EEPROM using Encoder. This is just the intial value on first run.
}
if (IKd == NULL)
{
IKd = 20;                  //Default initial D constant. can be changed and stored in EEPROM using Encoder. This is just the intial value on first run.
}
if (IKp > 99) 
{
IKp = 32;                  
}
if (IKi > 99) 
{
IKi = 2;                 
}
if (IKd > 99)
{
IKd = 20;               
}
Kp = IKp / 1.00;           //originally had this Kp as decimal increments to max 9.9 (divisible by 10.00). Found this not flexible enough so changed to max of 99 (hence divisible by 1.00)
Ki = IKi / 1.00;           //originally had this Ki as decimal increments to max 9.9 (divisible by 10.00). Found this not flexible enough so changed to max of 99 (hence divisible by 1.00)
Kd = IKd / 1.00;           //originally had this Kd as decimal increments to max 9.9 (divisible by 10.00). Found this not flexible enough so changed to max of 99 (hence divisible by 1.00)
if (hialarm == NULL) 
{
hialarm = 115;             //Default initial High Alarm Setpoint. can be changed and stored in EEPROM using Encoder. This is just the intial value on first run.
}
if (loalarm == NULL)
{
loalarm = 100;             //Default initial Low Alarm Setpoint. can be changed and stored in EEPROM using Encoder. This is just the intial value on first run.
}
if (tempset == NULL)
{
tempset = 110;             //Default initial Temperature Setpoint. can be changed and stored in EEPROM using Encoder. This is just the intial value on first run.
}
pinMode(hitemppin, OUTPUT);    
pinMode(lowtemppin, OUTPUT);  
pinMode(lowtempsilencepin, INPUT_PULLUP);
pinMode(encoderswitch,  INPUT_PULLUP); 
digitalWrite(lowtemppin, LOW);       //2, 4, 8 channel arduino relays often default to LOW = On & HIGH = Off. If you have single relays or relay is activating when NOT within Alarm SP change from HIGH to LOW.
digitalWrite(hitemppin, LOW);        //2, 4, 8 channel arduino relays often default to LOW = On & HIGH = Off. If you have single relays or relay is activating when NOT within Alarm SP change from HIGH to LOW.
silence = false;
menupressed = false;
cursor = false;
menu = 0;  



if (digitalRead(lowtempsilencepin) == LOW)
{
if (unit == 1)
{
unit = 2;
goto skipunit;
}
if (unit == 2)
{
unit = 1;
}
skipunit:;
EEPROM.write(6, unit);
delay(1000);
}

lcd.clear();
lcd.init();
lcd.backlight();
lcd.setCursor(0,0);
fixbrackets();
lcd.print("Hutchie's BBQ  ");  //Change to whatever you want to call it (Note: maximum 13 characters)
lcd.setCursor(18,0);
lcd.print(" %");
lcd.setCursor(0,1);
lcd.print("TeSP=");
lcd.setCursor(10,1);
lcd.print("TEMP=");
lcd.setCursor(18,1);
lcd.print((char)223);
lcd.setCursor(19,1);


if (unit == 1)
{
lcd.print("C");                
}
if (unit == 2)
{
lcd.print("F");              
}



lcd.setCursor(0,2);
lcd.print("LoSP=");
lcd.setCursor(10,2); 
lcd.print("HiSP=");
lcd.setCursor(0,3); 
lcd.print("PIDc=");
lcd.setCursor(5,3); 
lcd.print("p");
lcd.setCursor(10,3); 
lcd.print("i");
lcd.setCursor(15,3); 
lcd.print("d");
}  //end of set up

void loop(void)
{
silencems = millis(); 
hitempms = millis();
lowtempms = millis();  
cursorms = millis();  
if ((digitalRead(encoderswitch) == LOW) && (menupressed == false))
{
menupressed = true;
}
if ((digitalRead(encoderswitch) == HIGH) && (menupressed == true))
{ 
menupressed = false;
if (menu == 1) {
EEPROM.write(5, tempset);
delay(1000);
encoderPos = 0;
oldEncPos = 0;
}
if (menu == 2) {
EEPROM.write(4, loalarm);
delay(1000);
encoderPos = 0;
oldEncPos = 0;
}
if (menu == 3) {
EEPROM.write(3, hialarm);
delay(1000);
encoderPos = 0;
oldEncPos = 0;
}
if (menu == 4) {
EEPROM.write(0, (Kp * 1));
delay(1000);
encoderPos = 0;
oldEncPos = 0;
}
if (menu == 5) {
EEPROM.write(1, (Ki * 1));
delay(1000);
encoderPos = 0;
oldEncPos = 0;
}
if (menu == 6) {
EEPROM.write(2, (Kd * 1));
delay(1000);
encoderPos = 0;
oldEncPos = 0;
}
fixbrackets();
menu = menu + 1;
}
if (menu >= 7)
{
menu = 0;
}




//if menu = 0 then just run normal program  
if (menu == 0)
{
lcd.setCursor(18,1);
lcd.print((char)223);
temperature = readThermocouple();  //Normal Use. Reading Temperature from MAXX6675 thermocouple and probe.
//testtemp = analogRead(1);        //For Testing. If using 10K potentiometer (Left to GND. Middle to Analog Pin A1. Right to 5Vdc) to play around with different test temperatures.
//temperature = testtemp / 4;      //For Testing. If using 10K potentiometer (Left to GND. Middle to Analog Pin A1. Right to 5Vdc) to play around with different test temperatures.
Dtemperature = temperature;
Dtempset = tempset;
pid.setpoint(tempset);
pid.tune(Kp, Ki, Kd);   
pidvalue = pid.compute(temperature);
delay(250);
setPwmDuty(pidvalue/2.5);    
Iduty = pidvalue/2.5;
if (Iduty > 100)
{
Iduty = 100;
}
lcd.setCursor(6,1);



if (unit == 1)
{
lcd.print(tempset);                 
}
if (unit == 2)
{
lcd.print((tempset * 1.8) + 32,0);  
}



if (unit == 1)
{
if (temperature < 100)                   
{
lcd.setCursor(17,1);
lcd.print(" ");
}
if (temperature < 10)                 
{
lcd.setCursor(16,1);
lcd.print(" ");
}
lcd.setCursor(15,1);
lcd.print(temperature);                 


lcd.setCursor(6,2);
lcd.print(loalarm);                   


lcd.setCursor(16,2);
lcd.print(hialarm);         
}



if (unit == 2)
{
if (((temperature * 1.8) + 32) < 100)  
{
lcd.setCursor(17,1);
lcd.print(" ");
}
if (((temperature * 1.8) + 32) < 10)  
{
lcd.setCursor(16,1);
lcd.print(" ");
}
lcd.setCursor(15,1);
lcd.print((temperature * 1.8) + 32,0);  

lcd.setCursor(6,2);
lcd.print((loalarm * 1.8) + 32,0);    

lcd.setCursor(16,2);
lcd.print((hialarm * 1.8) + 32,0);    
}



lcd.setCursor(7,3);
lcd.print(Kp,0);
lcd.setCursor(12,3);
lcd.print(Ki,0);
lcd.setCursor(17,3);
lcd.print(Kd,0);
delay(500);
if (digitalRead(lowtempsilencepin) == LOW)
{
silencelastms = silencems;
silence = true;
}
if ((silencems - silencelastms > 600000) && (silence == true)) {
silence = false;
}
if ((temperature < loalarm) && (silence == true))
{
digitalWrite(lowtemppin, LOW);          //2, 4, 8 channel arduino relays often default to LOW = On & HIGH = Off. If you have single relays or relay is activating when NOT within Alarm SP change from HIGH to LOW.
lcd.setCursor(15,0) ;
lcd.print("SIL");
goto skipspeedwrite;
}
if ((temperature < loalarm) && (silence == false))   
{
lcd.setCursor(15,0) ;
lcd.print("LO ");
lowtempmode();   
goto skipspeedwrite;
}
if ((temperature > hialarm) && (Iduty < 2))
{
hitempmode();
lcd.setCursor(15,0) ;
lcd.print("HI");
lcd.setCursor(17,0) ;
lcd.print(" ");
goto skipspeedwrite;
}
if (Iduty < 100)
{
lcd.setCursor(17,0) ;
lcd.print(" ");
}
if (Iduty < 10)
{
lcd.setCursor(16,0) ;
lcd.print(" ");
}
digitalWrite(lowtemppin, LOW);      //2, 4, 8 channel arduino relays often default to LOW = On & HIGH = Off. If you have single relays or relay is activating when NOT within Alarm SP change from HIGH to LOW.
digitalWrite(hitemppin, LOW);       //2, 4, 8 channel arduino relays often default to LOW = On & HIGH = Off. If you have single relays or relay is activating when NOT within Alarm SP change from HIGH to LOW.
lcd.setCursor(15,0) ;
lcd.print(Iduty,0);
skipspeedwrite:;
} //end of if menu = 0
  


  
  
if (menu != 0)
{  
if (cursorms - cursorlastms > 1000)
{
cursorlastms = cursorms;
if (cursor == false)
{
cursor = true;
goto skipcurse;
}
if (cursor == true)
{
cursor = false;
}
}
skipcurse:
  
  

  
  
//if menu = 1 then adjusts temperature setpoint 
if (menu == 1)  
{
if (oldEncPos != encoderPos)
{
if (encoderPos > 250)
{
increment = 1;
}
else
{
increment = -1;
}
tempset = tempset + (increment);
oldEncPos = 0;
encoderPos = 0;
if (tempset > 250)
{
tempset = 0;
}
if (tempset < 0)
{
tempset = 250;
}
}

if (unit == 1)
{
if (tempset < 100)                      
{
lcd.setCursor(8,1); 
lcd.print(" ");
}
if (tempset < 10)                     
{
lcd.setCursor(7,1); 
lcd.print(" ");
}
lcd.setCursor(6,1);
lcd.print(tempset);                    
}


if (unit == 2)
{
if (((tempset * 1.8) + 32) < 100)   
{
lcd.setCursor(8,1); 
lcd.print(" ");
}
if (((tempset * 1.8) + 32) < 10)    
{
lcd.setCursor(7,1); 
lcd.print(" ");
}
lcd.setCursor(6,1);
lcd.print(((tempset * 1.8) + 32),0);  
}
if (cursor == true)
{
lcd.setCursor(5,1);
lcd.print("#");
lcd.setCursor(9,1);
lcd.print("#");
}  
if (cursor == false)
{
lcd.setCursor(5,1);
lcd.print("!");
lcd.setCursor(9,1);
lcd.print("!");
}  
}



  
//if menu = 2 then adjusts low alarm setpoint  
if (menu == 2)  
{
if (oldEncPos != encoderPos)
{
if (encoderPos > 250)
{
increment = 1;
}
else
{
increment = -1;
}
loalarm = loalarm + (increment);
oldEncPos = 0;
encoderPos = 0;
if (loalarm > 250)
{
loalarm = 0;
}
if (loalarm < 0)
{
loalarm = 250;
}
}

if (unit == 1)
{
if (loalarm < 100)   
{
lcd.setCursor(8,2); 
lcd.print(" ");
}
if (loalarm < 10)  
{
lcd.setCursor(7,2); 
lcd.print(" ");
}
lcd.setCursor(6,2);
lcd.print(loalarm);  
}

if (unit == 2)
{
if (((loalarm * 1.8) + 32) < 100) 
{
lcd.setCursor(8,2); 
lcd.print(" ");
}
if (((loalarm * 1.8) + 32) < 10) 
{
lcd.setCursor(7,2); 
lcd.print(" ");
}
lcd.setCursor(6,2);
lcd.print(((loalarm * 1.8) + 32),0); 
}
if (cursor == true)
{
lcd.setCursor(5,2);
lcd.print("#");
lcd.setCursor(9,2);
lcd.print("#");
}  
if (cursor == false)
{
lcd.setCursor(5,2);
lcd.print("!");
lcd.setCursor(9,2);
lcd.print("!");
}  
}
    




  
//if menu = 3 then adjusts High Temp Mode Setpoint
if (menu == 3)  
{
if (oldEncPos != encoderPos)
{
if (encoderPos > 250)
{
increment = 1;
}
else
{
increment = -1;
}
hialarm = hialarm + (increment);
oldEncPos = 0;
encoderPos = 0;
if (hialarm > 250)
{
hialarm = 0;
}
if (hialarm < 0)
{
hialarm = 250;
}
}

if (unit == 1)
{
if (hialarm < 100)        
{
lcd.setCursor(18,2); 
lcd.print(" ");
}
if (hialarm < 10)     
{
lcd.setCursor(17,2); 
lcd.print(" ");
}
lcd.setCursor(16,2);
lcd.print(hialarm);     
}

if (unit == 2)
{
if (((hialarm * 1.8) + 32) < 100) 
{
lcd.setCursor(18,2); 
lcd.print(" ");
}
if (((hialarm * 1.8) + 32) < 10) 
{
lcd.setCursor(17,2); 
lcd.print(" ");
}
lcd.setCursor(16,2);
lcd.print(((hialarm * 1.8) + 32),0); 
}

if (cursor == true)
{
lcd.setCursor(15,2);
lcd.print("#");
lcd.setCursor(19,2);
lcd.print("#");
}  
if (cursor == false)
{
lcd.setCursor(15,2);
lcd.print("!");
lcd.setCursor(19,2);
lcd.print("!");
}  
}
  
  



  
//if menu = 4 then adjusts P  
if (menu == 4)  
{
if (oldEncPos != encoderPos)
{
if (encoderPos > 250)
{
increment = 1;
}
else
{
increment = -1;
}
Kp = Kp + increment;
oldEncPos = 0;
encoderPos = 0;
if (Kp > 99)
{
Kp = 0;
}
if (Kp < 0)
{
Kp = 99;
}
}
if (Kp < 10)
{
lcd.setCursor(8,3);
lcd.print(" ");
}
lcd.setCursor(7,3);
lcd.print(Kp, 0);
if (cursor == true)
{
lcd.setCursor(6,3);
lcd.print("#");
lcd.setCursor(9,3);
lcd.print("#");
}  
if (cursor == false)
{
lcd.setCursor(6,3);
lcd.print("!");
lcd.setCursor(9,3);
lcd.print("!");
}  
}
  


  
  
//if menu = 5 then adjusts I  
if (menu == 5)  
{
if (oldEncPos != encoderPos)
{
if (encoderPos > 250)
{
increment = 1;
}
else
{
increment = -1;
}
Ki = Ki + increment;
oldEncPos = 0;
encoderPos = 0;
if (Ki > 99)
{
Ki = 0;
}
if (Ki < 0)
{
Ki = 99;
}
}
if (Ki < 10)
{
lcd.setCursor(13,3);
lcd.print(" ");
}
lcd.setCursor(12,3);
lcd.print(Ki, 0);
if (cursor == true)
{
lcd.setCursor(11,3);
lcd.print("#");
lcd.setCursor(14,3);
lcd.print("#");
}  
if (cursor == false)
{
lcd.setCursor(11,3);
lcd.print("!");
lcd.setCursor(14,3);
lcd.print("!");
}  
}
  
  

  
  
//if menu = 6 then adjusts D
if (menu == 6)  
{
if (oldEncPos != encoderPos)
{
if (encoderPos > 250)
{
increment = 1;
}
else
{
increment = -1;
}
Kd = Kd + increment;
oldEncPos = 0;
encoderPos = 0;
if (Kd > 99)
{
Kd = 0;
}
if (Kd < 0)
{
Kd = 99;
}
}
if (Kd < 10)
{
lcd.setCursor(18,3);
lcd.print(" ");
}
lcd.setCursor(17,3);
lcd.print(Kd,0);
if (cursor == true)
{
lcd.setCursor(16,3);
lcd.print("#");
lcd.setCursor(19,3);
lcd.print("#");
}  
if (cursor == false)
{
lcd.setCursor(16,3);
lcd.print("!");
lcd.setCursor(19,3);
lcd.print("!");
}  
}  
  


   
  
}  // end of if menu != 0 
}  // end of void loop






void hitempmode(void)
{
if (hitempms - hitempmsLast > (hitemp ? hitempoff : hitempon)) {
digitalWrite(hitemppin, hitemp = !hitemp);
hitempmsLast = hitempms;
}
}
  
void lowtempmode(void)
{
if (lowtempms - lowtempmsLast > (lowtemp ? lowtempoff : lowtempon)) {
digitalWrite(lowtemppin, lowtemp = !lowtemp);
lowtempmsLast = lowtempms;
}
}

void fixbrackets(void)
{
//write all brackets to LCD
lcd.setCursor(5,1);
lcd.print("(");
lcd.setCursor(9,1);
lcd.print(")");
lcd.setCursor(5,2);
lcd.print("(");
lcd.setCursor(9,2);
lcd.print(")");
lcd.setCursor(15,2);
lcd.print("(");
lcd.setCursor(19,2);
lcd.print(")");
lcd.setCursor(6,3);
lcd.print("(");
lcd.setCursor(9,3);
lcd.print(")");
lcd.setCursor(11,3);
lcd.print("(");
lcd.setCursor(14,3);
lcd.print(")");
lcd.setCursor(16,3);
lcd.print("(");
lcd.setCursor(19,3);
lcd.print(")");
}

void PinA(){
cli();
reading = PIND & 0xC; 
if(reading == B00001100 && aFlag) { 
encoderPos --; 
bFlag = 0; 
aFlag = 0; 
}
else if (reading == B00000100) bFlag = 1; 
sei();
}

void PinB(){
cli(); 
reading = PIND & 0xC;
if (reading == B00001100 && bFlag) { 
encoderPos ++;
bFlag = 0; 
aFlag = 0; 
}
else if (reading == B00001000) aFlag = 1;
sei(); //restart interrupts
}

double readThermocouple()
{
uint16_t v;
pinMode(5, OUTPUT);
pinMode(6, INPUT);
pinMode(4, OUTPUT);
digitalWrite(5, LOW);
delay(1);
v = shiftIn(6, 4, MSBFIRST);
v <<= 8;
v |= shiftIn(6, 4, MSBFIRST);
digitalWrite(5, HIGH);
if (v & 0x4) 
{    
return NAN;     
}
v >>= 3;
return v*0.25;
}


void setPwmDuty(byte duty) {
OCR1A = (word) (duty*TCNT1_TOP)/100;
}
